Typedefs | Enumerations | Functions

# exception.h File Reference

`#include "wizard/semaphore.h"`

Go to the source code of this file.

## Typedefs
typedef struct _ExceptionInfo | ExceptionInfo
typedef void(* | ErrorHandler )(const ExceptionType, const char *, const char *)
typedef void(* | FatalErrorHandler )(const ExceptionType, const char *, const char *)
typedef void(* | WarningHandler )(const ExceptionType, const char *, const char *)
## Enumerations
enum | DomainType { RandomDomain = 0, HashDomain = 1, EntropyDomain = 2, RepairDomain = 3, MACDomain = 4, CipherDomain = 5, KeymapDomain = 6, AuthenticateDomain = 7, KeyringDomain = 8, ParseDomain = 9, UserDomain = 10, CacheDomain = 11, LogDomain = 12, StringDomain = 13, ResourceDomain = 14, MiscellaneousDomain = 15 }
enum | ErrorType { MemoryError = 0, EnumerateError = 1, AuthenticateUserError = 2, KeyError = 3, HashIOError = 4, TimeError = 5, TamperError = 6, AssertError = 7 }
enum | ExceptionType { UndefinedException, WarningException = 300, OptionWarning = 305, RandomWarning = 310, HashWarning = 315, MACWarning = 320, EntropyWarning = 325, ConfigureWarning = 330, CipherWarning = 335, KeymapWarning = 340, AuthenticateWarning = 345, KeyringWarning = 350, ParseWarning = 355, UserWarning = 360, SplayTreeWarning = 365, HashmapWarning = 370, LogWarning = 375, StringWarning = 380, FileWarning = 385, BlobWarning = 390, ResourceWarning = 395, ErrorException = 400, OptionError = 405, RandomError = 410, HashError = 415, MACError = 420, EntropyError = 425, ConfigureError = 430, CipherError = 435, KeymapError = 440, AuthenticateError = 445, KeyringError = 450, ParseError = 455, UserError = 460, SplayTreeError = 465, HashmapError = 470, LogError = 475, StringError = 480, FileError = 485, BlobError = 490, ResourceError = 495, FatalErrorException = 700, OptionFatalError = 705, RandomFatalError = 710, HashFatalError = 715, MACFatalError = 720, EntropyFatalError = 725, ConfigureFatalError = 730, CipherFatalError = 735, KeymapFatalError = 740, AuthenticateFatalError = 745, KeyringFatalError = 750, ParseFatalError = 755, UserFatalError = 760, SplayTreeFatalError = 765, HashmapFatalError = 770, LogFatalError = 775, StringFatalError = 780, FileFatalError = 785, BlobFatalError = 790, ResourceFatalError = 795 }
## Functions
WizardExport char * | GetExceptionMessage (const int)
WizardExport const char * | GetLocaleExceptionMessage (const ExceptionType, const char *)
WizardExport const char ** | GetLocaleMessage (const char *)
WizardExport ErrorHandler | SetErrorHandler (ErrorHandler)
WizardExport ExceptionInfo * | AcquireExceptionInfo (void)
WizardExport ExceptionInfo ** | DestroyExceptionInfo (ExceptionInfo *)
WizardExport ExceptionType | GetExceptionSeverity (const ExceptionInfo *)
WizardExport FatalErrorHandler | SetFatalErrorHandler (FatalErrorHandler)
WizardExport WizardBooleanType | ListLocaleInfo (FILE *, ExceptionInfo *)
WizardExport WizardBooleanType | ThrowException (ExceptionInfo *, const ExceptionType, const char *, const char *)
WizardExport WizardBooleanType | ThrowWizardException (ExceptionInfo *, const char *, const char *, const size_t, const ExceptionType, const char *,...) wizard_attribute((format(printf
WizardExport WizardBooleanType WizardExport void | CatchException (ExceptionInfo *)
WizardExport WizardBooleanType WizardExport void | ClearWizardException (ExceptionInfo *)
WizardExport WizardBooleanType WizardExport void | DestroyLocaleInfo (void)
WizardExport WizardBooleanType WizardExport void | GetExceptionInfo (ExceptionInfo *)
WizardExport WizardBooleanType WizardExport void | InheritException (ExceptionInfo *, const ExceptionInfo *)
WizardExport WizardBooleanType WizardExport void | WizardError (const ExceptionType, const char *, const char *)
WizardExport WizardBooleanType WizardExport void | WizardFatalError (const ExceptionType, const char *, const char *)
WizardExport WizardBooleanType WizardExport void | WizardWarning (const ExceptionType, const char *, const char *)
WizardExport WarningHandler | SetWarningHandler (WarningHandler)

## Typedef Documentation

typedef void(* ErrorHandler)(const ExceptionType, const char *, const char *)

typedef struct _ExceptionInfo ExceptionInfo

typedef void(* FatalErrorHandler)(const ExceptionType, const char *, const char *)

typedef void(* WarningHandler)(const ExceptionType, const char *, const char *)

## Enumeration Type Documentation

enum DomainType

Enumerator:

  RandomDomain |
  HashDomain |
  EntropyDomain |
  RepairDomain |
  MACDomain |
  CipherDomain |
  KeymapDomain |
  AuthenticateDomain |
  KeyringDomain |
  ParseDomain |
  UserDomain |
  CacheDomain |
  LogDomain |
  StringDomain |
  ResourceDomain |
  MiscellaneousDomain |

enum ErrorType

Enumerator:

  MemoryError |
  EnumerateError |
  AuthenticateUserError |
  KeyError |
  HashIOError |
  TimeError |
  TamperError |
  AssertError |

enum ExceptionType

Enumerator:

  UndefinedException |
  WarningException |
  OptionWarning |
  RandomWarning |
  HashWarning |
  MACWarning |
  EntropyWarning |
  ConfigureWarning |
  CipherWarning |
  KeymapWarning |
  AuthenticateWarning |
  KeyringWarning |
  ParseWarning |
  UserWarning |
  SplayTreeWarning |
  HashmapWarning |
  LogWarning |
  StringWarning |
  FileWarning |
  BlobWarning |
  ResourceWarning |
  ErrorException |
  OptionError |
  RandomError |
  HashError |
  MACError |
  EntropyError |
  ConfigureError |
  CipherError |
  KeymapError |
  AuthenticateError |
  KeyringError |
  ParseError |
  UserError |
  SplayTreeError |
  HashmapError |
  LogError |
  StringError |
  FileError |
  BlobError |
  ResourceError |
  FatalErrorException |
  OptionFatalError |
  RandomFatalError |
  HashFatalError |
  MACFatalError |
  EntropyFatalError |
  ConfigureFatalError |
  CipherFatalError |
  KeymapFatalError |
  AuthenticateFatalError |
  KeyringFatalError |
  ParseFatalError |
  UserFatalError |
  SplayTreeFatalError |
  HashmapFatalError |
  LogFatalError |
  StringFatalError |
  FileFatalError |
  BlobFatalError |
  ResourceFatalError |

## Function Documentation

WizardExport ExceptionInfo* AcquireExceptionInfo | ( | void |  | ) |

WizardExport WizardBooleanType WizardExport void CatchException | ( | ExceptionInfo * |  | ) |

WizardExport WizardBooleanType WizardExport void ClearWizardException | ( | ExceptionInfo * |  | ) |

WizardExport ExceptionInfo* * DestroyExceptionInfo | ( | ExceptionInfo * |  | ) |

References DestroyLinkedList(), DestroySemaphoreInfo(), _ExceptionInfo::exceptions, LockSemaphoreInfo(), _ExceptionInfo::relinquish, RelinquishWizardMemory(), _ExceptionInfo::semaphore, _ExceptionInfo::severity, _ExceptionInfo::signature, UnlockSemaphoreInfo(), WizardFalse, and WizardSignature.

Referenced by AcquireRandomInfo(), CloseWizardLog(), GenerateSecretKey(), IsEventLogging(), LogWizardEventList(), SetLogEventMask(), SetLogFormat(), TranslateEvent(), and WizardToMime().

WizardExport WizardBooleanType WizardExport void DestroyLocaleInfo | ( | void |  | ) |

WizardExport WizardBooleanType WizardExport void GetExceptionInfo | ( | ExceptionInfo * |  | ) |

WizardExport char* GetExceptionMessage | ( | const | int | ) |

References ConstantString(), and CopyWizardString().

WizardExport ExceptionType GetExceptionSeverity | ( | const ExceptionInfo * |  | ) |

References _ExceptionInfo::severity, _ExceptionInfo::signature, and WizardSignature.

WizardExport const char* GetLocaleExceptionMessage | ( | const | ExceptionType,
|  | const char * |  |
| ) |  |  |

WizardExport const char* * GetLocaleMessage | ( | const char * |  | ) |

Referenced by GetLocaleExceptionMessage().

WizardExport WizardBooleanType WizardExport void InheritException | ( | ExceptionInfo * | ,
|  | const ExceptionInfo * |  |
| ) |  |  |

WizardExport WizardBooleanType ListLocaleInfo | ( | FILE * | ,
|  | ExceptionInfo * |  |
| ) |  |  |

WizardExport ErrorHandler SetErrorHandler | ( | ErrorHandler |  | ) |

References error_handler.

WizardExport FatalErrorHandler SetFatalErrorHandler | ( | FatalErrorHandler |  | ) |

References fatal_error_handler.

WizardExport WarningHandler SetWarningHandler | ( | WarningHandler |  | ) |

References warning_handler.

WizardExport WizardBooleanType ThrowException | ( | ExceptionInfo * | ,
|  | const | ExceptionType,
|  | const char * | ,
|  | const char * |  |
| ) |  |  |

WizardExport WizardBooleanType ThrowWizardException | ( | ExceptionInfo * | ,
|  | const char * | ,
|  | const char * | ,
|  | const | size_t,
|  | const | ExceptionType,
|  | const char * | ,
|  |  | ... |
| ) |  |  |

WizardExport WizardBooleanType WizardExport void WizardError | ( | const | ExceptionType,
|  | const char * | ,
|  | const char * |  |
| ) |  |  |

WizardExport WizardBooleanType WizardExport void WizardFatalError | ( | const | ExceptionType,
|  | const char * | ,
|  | const char * |  |
| ) |  |  |

WizardExport WizardBooleanType WizardExport void WizardWarning | ( | const | ExceptionType,
|  | const char * | ,
|  | const char * |  |
| ) |  |  |

References warning_handler.

Referenced by CatchException().